program testLibListeChaineeDEntiers;

uses ListeChaineeDEntiers, LibListeChaineeDEntiers;

function liste123() : TListeChaineeDEntiers;
begin
   liste123 := listeVide();
   ajouter(liste123,3);
   ajouter(liste123,2);
   ajouter(liste123,1);
end;

function liste12321() : TListeChaineeDEntiers;
begin
   liste12321 := listeVide();
   ajouter(liste12321,1);
   ajouter(liste12321,2);
   ajouter(liste12321,3);
   ajouter(liste12321,2);
   ajouter(liste12321,1);
end;

function liste456() : TListeChaineeDEntiers;
begin
   liste456 := listeVide();
   ajouter(liste456,6);
   ajouter(liste456,5);
   ajouter(liste456,4);
end;

function liste123456() : TListeChaineeDEntiers;
begin
   liste123456 := listeVide();
   ajouter(liste123456,6);
   ajouter(liste123456,5);
   ajouter(liste123456,4);   
   ajouter(liste123456,3);
   ajouter(liste123456,2);
   ajouter(liste123456,1);
end;

procedure testSontEgales1();
var
   l : TListeChaineeDEntiers;
begin
   l := liste123();
   write('  sontEgales(l,l) : ');
   if sontEgales(l,l) then
      writeln('OK')
   else
      writeln('KO');
   supprimer(l)
end;

procedure testSontEgales2();
var
   l1,l2 : TListeChaineeDEntiers;
begin
   l1 := liste123();
   l2 := liste123();
   write('  sontEgales(l1,l2) (avec l1 et l2 qui possedent les meme elements) : ');
   if sontEgales(l1,l2) then
      writeln('OK')
   else
      writeln('KO');
   supprimer(l1);
   supprimer(l2)  
end;

procedure testSontEgales3();
var
   l1,l2 : TListeChaineeDEntiers;
begin
   l1 := liste123();
   l2 := liste456();
   write('  sontEgales(l1,l2) (avec l1 et l2 qui ne possedent pas les meme elements) : ');
   if not sontEgales(l1,l2) then
      writeln('OK')
   else
      writeln('KO');
   supprimer(l1);
   supprimer(l2)  
end;

procedure testCopier();
var
   l1,l2 : TListeChaineeDEntiers;
begin
   l1 := liste123();
   l2 := copier(l1);
   write('  copier(l) : ');
   if sontEgales(l1,l2) then
      writeln('OK')
   else
      writeln('KO');
   supprimer(l1);
   supprimer(l2)  
end;

procedure testEstPresent1();
var
   l : TListeChaineeDEntiers;
begin
   l := liste123();
   write('  estPresent(l,e) (avec e qui est reellement present au debut): ');
   if estPresent(l,1) then
      writeln('OK')
   else
      writeln('KO');
   supprimer(l)
end;

procedure testEstPresent2();
var
   l : TListeChaineeDEntiers;
begin
   l := liste123();
   write('  estPresent(l,e) (avec e qui est reellement present a la fin): ');
   if estPresent(l,3) then
      writeln('OK')
   else
      writeln('KO');
   supprimer(l)
end;

procedure testEstPresent3();
var
   l : TListeChaineeDEntiers;
begin
   l := liste123();
   write('  estPresent(l,e) (avec e qui est reellement present, cas general): ');
   if estPresent(l,2) then
      writeln('OK')
   else
      writeln('KO');
   supprimer(l)
end;

procedure testEstPresent4();
var
   l : TListeChaineeDEntiers;
begin
   l := liste123();
   write('  estPresent(l,e) (avec e qui n''est pas present): ');
   if not estPresent(l,5) then
      writeln('OK')
   else
      writeln('KO');
   supprimer(l)
end;

procedure testEstEnOrdre1();
var
   l : TListeChaineeDEntiers;
begin
   l := liste123();
   write('  estEnOrdreCroissant(l) (avec la liste (1 2 3)): ');
   if estEnOrdreCroissant(l) then
      writeln('OK')
   else
      writeln('KO');
   supprimer(l)
end;

procedure testEstEnOrdre2();
var
   l : TListeChaineeDEntiers;
begin
   l := liste12321();
   write('  estEnOrdreCroissant(l) (avec la liste (1 2 3 2 1)): ');
   if not estEnOrdreCroissant(l) then
      writeln('OK')
   else
      writeln('KO');
   supprimer(l)
end;

procedure testConcatener();
var
   l1,l2,l3 : TListeChaineeDEntiers;
begin
   l1 := liste123();
   l2 := liste456();
   l3 := liste123456();
   concatener(l1,l2);
   write('  concatener(l1,l2) : ');
   if sontEgales(l1,l3) then
      writeln('OK')
   else
      writeln('KO');
   supprimer(l1);
   supprimer(l3)
end;

begin
   writeln('Tests unitaires de la librairie LibListeChaineeDEntiers');
   testSontEgales1();
   testSontEgales2();
   testSontEgales3();
   testCopier();
   testEstPresent1();
   testEstPresent2();
   testEstPresent3();
   testEstPresent4();
   testEstEnOrdre1();
   testEstEnOrdre2();
   testConcatener();
end.

